function harmOsz(n)

if (nargin<1)||(n<2)||(n>50)
    n=16;
end
fh=figure;
set(fh,'visible','off','position',[0,0,600,600],...
    'name','Harmonischer Oszillator','numbertitle','off')
x_lim1=sqrt(2*n);
x_pot=linspace(-x_lim1,x_lim1,100);
y_pot=0.5*x_pot.^2;
ah1=axes;
set(ah1,'position', [0,0.3,0.7,0.7],'xlim',[-(x_lim1+1.5),(x_lim1+1.5)],'ylim',[0,n])
set(ah1,'visible','off')
for count=0:(n-1)
	    line([-(x_lim1+1.5),(x_lim1+1.5)],[count+0.5,count+0.5],'color','k')
end
line(x_pot,y_pot,'color','g')

fine_x=200;
n1=uint8(0:1:(n-1));
x_phi=linspace(-(x_lim1+1.5),(x_lim1+1.5),fine_x);
[x_phi,y_phi]=hermiteval(x_phi,n1);
add=repmat((0.5:1:(n-0.5))',1,fine_x);
line(x_phi',(y_phi*0.5+add)','color','b')
energy_linehandle=line([-(x_lim1+1.5),(x_lim1+1.5)],[0.5,0.5],'color','r');
slh=zeros(1,n);
for n1=1:n
    slhh(n1)=uicontrol('style','slider','units','normalized',...
        'position',[0.7,1-n1*0.7/n,0.2,0.7/n],...
        'min',0,'max',10,'sliderstep',[0.1,0.3],'value',0);
end
slvh=uicontrol('style','slider','units','normalized',...
    'position',[0.93,0.3,0.04,0.7],...
    'min',0,'max',n-1,'sliderstep',[1/(n-1),3/(n-1)],'value',0,...
    'callback',{@slider_change});
uicontrol('style','pushbutton','units','normalized','position',...
    [0.7,0.05,0.3,0.05],'string','run mix','callback',{@run_mix});
uicontrol('style','pushbutton','units','normalized','position',...
    [0.7,0.15,0.3,0.05],'string','run gauss','callback',{@run_gauss});
ah2=axes;
set(ah2,'position', [0,0,0.7,0.3],'xlim',[-(x_lim1+1.5),(x_lim1+1.5)],'ylim',[0,1])
set(ah2,'visible','off')
line_anim_h=line([-(x_lim1+1.5),(x_lim1+1.5)],[0,0],'color','b');

movegui(fh,'center')
set(fh,'visible','on')

    function slider_change(source,eventdata)
        value_slider=get(slvh,'value')+0.5;
        set(energy_linehandle,'xdata',[-(x_lim1+1.5),(x_lim1+1.5)],...
            'ydata',[value_slider,value_slider])
    end

    function run_mix(source,eventdata)
        
        n1=uint8([0:(n-1)]);
        coef=flipud(cell2mat(get(slhh,'value')))';
        if(any(coef(:)>0))
            fine_x=500;
            fine_t=100;
            t_num=1;
            w=1;
            
            [x_plot,rho_plot]=t_develope(n1,coef,fine_x,fine_t,w,(x_lim1+1.5),false);
            
            
            set(ah2,'ylim',[0,max([rho_plot(:);1])])
            set(line_anim_h,'xdata',x_plot(:,1),'ydata',rho_plot(:,1))
            dt=2*pi/(w*fine_t);
            for k=1:(fine_t)
                pause(dt)
                set(line_anim_h,'ydata',rho_plot(:,k))
            end
        else
            warning('Please choose coefficients!')
        end
    end

    function run_gauss(source,eventdata)
        n1=uint8(0:1:50);
        lamda=sqrt(get(slvh,'value'))*exp(i*pi/2);
        fine_x=500;
        fine_t=100;
        t_num=1;
%        x_lim=abs(lamda)*1.5+2;
        w=1;
        n2=double(n1);
        coef=exp(-abs(lamda)^2/2)*lamda.^n2./sqrt(gamma(n2+1));
        
        [x_plot,rho_plot]=t_develope(n1,coef,fine_x,fine_t,w,(x_lim1+1.5),true);
        
        
        set(ah2,'ylim',[0,max([rho_plot(:);1])])
        set(line_anim_h,'xdata',x_plot(:,1),'ydata',rho_plot(:,1))
        dt=2*pi/(w*fine_t);
        for k=1:(fine_t)
            pause(dt)
            set(line_anim_h,'ydata',rho_plot(:,k))
        end


    end
end
